$(function()
{
    var jFaculty = $('#facultySelect');
    var jGrade = $('#gradeSelect');
    var jGroup = $('#groupSelect');
    
    jFaculty.find("[value='0']").attr('selected', 'selected');
    jGrade.find("[value='0']").attr('selected', 'selected');
    jGroup.find("[value='0']").attr('selected', 'selected');
    
    jGrade.attr('disabled', 'disabled');
    jGroup.attr('disabled', 'disabled');


    // Переключение страниц
    $('body').on('click', '.paginatorLink', function() {
        $('.paginatorPage').addClass('hiddenPage');
        $('.paginator_item').removeClass('selectedPageNum');
        $('#' + this.id).removeClass('hiddenPage');
        $(this).children('.paginator_item').addClass('selectedPageNum');
    });
    
    // Выбор факультета
    jFaculty.change(function() {
        if ((jFaculty.find('option:selected').val() != '0')) {
            jGrade.removeAttr('disabled');
        } else {
            jGrade.attr('disabled', 'disabled');
        }

        jGroup.attr('disabled', 'disabled');
        $("#studyGroupSelect").html('<option value="0">— Учебная группа —</option>');
    }).change(searchStudents);

    // Выбор курса
    jGrade.change(function() {
        jGroup.attr('disabled', 'disabled');
        jGroup.empty();
        jGroup.html('<option value="0">— Учебная группа —</option>');

        if ((jGrade.find('option:selected').val() != '0')) {
            $.post(URLdir + 'handler/admStudents/getGroups', {
                'facultyID': jFaculty.find('option:selected').val(),
                'gradeNum': jGrade.find('option:selected').val()
            }, updateGroupsList, "json");
        }
    }).change(searchStudents);

    function updateGroupsList(data) {
        $.each(data, function(i) {
            //jGroup.append('<optgroup label="'+data[i].SpecName+'">');
            $.each(data[i].Groups, function(j) {
                var group = data[i].Groups[j];
                jGroup.append('<option value="' + group.ID + '">' + group.Num + ' группа</option>');
            });
            jGroup.append('</optgroup>');
        });
        jGroup.removeAttr("disabled");
    }
    
    // Выбор группы
    jGroup.change(searchStudents);

    // Search by name
    var jStudentName = $("#studentName");
    var prevNameValue = '';

    var typewatch = (function() {
        var timer = 0;
        return function(callback, ms) {
            clearTimeout(timer);
            timer = setTimeout(callback, ms);
        };
    })();

    var updateList = function(e) {
        typewatch(function() {
            if (prevNameValue != jStudentName.val())
                searchStudents();
            prevNameValue = jStudentName.val();
            $(this).blur();
        }, 700);
    };

    jStudentName
        .keyup(updateList)
        .bind("paste", updateList);

    function searchStudents() {
        var arr = {
            'facultyID' : +jFaculty.find('option:selected').val(),
            'gradeID'   : +jGrade.find('option:selected').val(),
            'groupID'   : +jGroup.find('option:selected').val(),
            'name'      : jStudentName.val()
        };

        if (!arr.facultyID || !arr.gradeID)
            return;
        if (arr.name.length >= 3)
            updateStudentsList('admStudents/getStudentsByName?dean', arr);
        else if (arr.groupID)
            updateStudentsList('admStudents/getStudentsList?dean', arr);
    }

    function updateStudentsList(method, params) {
        $("#search_results").html('<div class="search_load"><img src="' + URLdir + 'media/img/load.gif"/></div>');
        $.post(URLdir + 'handler/' + method, params, function(data) {
            $("#search_results").html(data);
        });
    }
});